<?php
require_once (dirname(__FILE__) . '/config.php');

if (! file_exists(dirname(__FILE__) . '/data/queue.json')) {
 file_put_contents(dirname(__FILE__) . '/data/queue.json', '{}');
}

$fp = fopen(dirname(__FILE__) . '/data/queue.json', "r+");

if (flock($fp, LOCK_EX)) { // acquire an exclusive lock
 
 $config = json_decode(file_get_contents(dirname(__FILE__) . '/data/queue.json'), true);
 if ($config === false) {
  _die(500, "no config found");
 }
 
 if (isset($_REQUEST["type"])) {
  $event = array(
    "type" => $_REQUEST["type"],
    "do" => $_REQUEST["do"],
    "value" => $_REQUEST["value"],
    "id" => $_REQUEST["id"],
    "time" => microtime(true) 
  );
  if ($event["type"] == "postit") {
   switch($event["do"]) {
    case "set-position":
     $id = $_REQUEST["id"];
     // additionally update x,y in message file
     if (file_exists(dirname(__FILE__) . '/data/' . substr($id, 1) . '.ok')) {
      $o = json_decode(file_get_contents(dirname(__FILE__) . '/data/' . substr($id, 1) . '.ok'));
      $o->x = $event["value"]["x"];
      $o->y = $event["value"]["y"];
      file_put_contents(dirname(__FILE__) . '/data/' . substr($id, 1) . '.ok', json_encode($o));
     } else if (file_exists(dirname(__FILE__) . '/data/' . substr($id, 1) . '.new')) {
      $o = json_decode(file_get_contents(dirname(__FILE__) . '/data/' . substr($id, 1) . '.new'));
      $o->x = $event["value"]["x"];
      $o->y = $event["value"]["y"];
      file_put_contents(dirname(__FILE__) . '/data/' . substr($id, 1) . '.new', json_encode($o));
     }
     break;
    default:
     _die(500, "unkown event " + $event["do"]);
   }
  } else {
   _die(500, "unkown event type " + $event["type"]);
  }
  if (! isset($config["events"])) {
   $config["events"] = array();
  }
  $config["events"][] = $event;
  
  // reduce events to t-15s
  $limit = time() - 15;
  foreach($config["events"] as $index => $e) {
   if ($e["time"] < $limit) {
    unset($config["events"][$index]);
   }
  }
  
  // persist
  $s = json_encode($config);
  ftruncate($fp, 0); // truncate file
  fwrite($fp, $s);
  fflush($fp); // flush output before releasing the lock
 }
 flock($fp, LOCK_UN); // release the lock
} else {
 _die(500, "queue lock failed");
}

fclose($fp);

$events = array();
if (isset($config["events"])) {
 foreach($config["events"] as $index => $e) {
  if (! isset($_REQUEST["time"]) || ($e["time"] > $_REQUEST["time"])) {
   $events[] = $config["events"][$index];
  }
 }
}
header('Content-type: application/json; charset=utf-8');
echo (json_encode($events));

?>
